import numpy as np
import matplotlib.pyplot as plt

x0 = float(input("Entrer la valeur de l'allongement initial x0 (en cm):   "))
m = float(input("Entrer la valeur de la masse m (en kg):   "))
k = float(input("Entrer la valeur de la constante de raideur k (en N/m):   "))
L = float(input("Entrer la valeur de l'amortissement lambda (en N.s/m:   "))
n = float(input("Entrer le nombre de pseudo-périodes à afficher :   "))

w0=np.sqrt(k/m)
Q = m*w0/L
w=w0*np.sqrt(1-1/(4*Q**2))
A=x0
B=x0/(2*Q)

t = np.linspace(0, n*2/w*np.pi, 1000)
f = np.exp(-w0/(2*Q)*t) * (A*np.cos(w*t) + B*np.sin(w*t))
print("Valeur de la pulsation :",round(w,1), " s-1")

plt.plot(t, f)
plt.xlabel('t (en s)')
plt.ylabel('x (en cm)')
plt.title("Evolution de l'abscisse du ressort")
plt.grid()
plt.show()
