"""
Exemple de résolution d'équations différentielles :
équation d'ordre 1 : di/dt + i/tau = B/tau
"""

from matplotlib.widgets import Cursor
from scipy import *
from pylab import *
from scipy.integrate import odeint      # Module de résolution des équations différentielles

# Coefficients et conditions initiales

R = float(input("entrer la valeur de R (en ohm) :   "))
r = float(input("entrer la valeur de r (en ohm) :   "))
L = float(input("entrer la valeur de L (en henry):    "))
n = int(input("entrer un multiple de tau:..."))
I0 = 0
E = 2

# calcul de tau theorique
def calculTau(L,R,r):
    tau = L/(R+r)       
    return tau

tau=calculTau(L,R,r)
print("Valeur de tau :",round(tau,5), " s")
Fin=n*tau

# Création des valeurs de dérivée
def deriv(syst, t):
    y = syst[0]                         # Variable y(t) ici i(t)
    dydt=-y/tau + E/(tau*(R+r))                 # Equation différentielle
    return [dydt]                       # Dérivées des variables

# Paramètres d'intégration
start = 0
end = Fin
numsteps = 200
t = linspace(start,end,numsteps)

# Résolution
y0=I0
syst_CI=array([y0])                     # Tableau des CI
Sols=odeint(deriv,syst_CI,t)            # Résolution numérique de l'équation différentielle

# Récupération des solutions
y = Sols[:, 0]

# Graphique
fig=subplot()
plot ( t , y, 'b-*', linewidth=1,  label="Dipôle RL")
grid()
xlabel("t (s)", fontsize=16)            # Label de l'axe des abscisses
ylabel("i (A)", fontsize=16)           # Label de l'axe des ordonnées
legend(loc = 'best')

# curseur pour lire une valeur
Cursor(fig, useblit=True, color='red', linewidth=1)
show()



