"""
Exemple de résolution d'équations différentielles :
équation d'ordre 1 : dc/dt + c/tau = 0
"""

from matplotlib.widgets import Cursor
from scipy import *
from pylab import *
from scipy.integrate import odeint      # Module de résolution des équations différentielles

# Coefficients et conditions initiales

c0 = float(input("entrer la valeur de la concentration initiale (en mol/L):    "))
n = float(input("entrer un multiple de tau:..."))
k = 0.0036

# calcul de tau theorique
def calculTau(L):
    tau = 1/k 
    return tau

tau=calculTau(k)
#print("Valeur de tau :",round(tau,5), " s")
Fin=n*tau

# Création des valeurs de dérivée
def deriv(syst, t):
    y = syst[0]                         # Variable y(t) ici c(t)
    dydt=-y/tau                 # Equation différentielle
    return [dydt]                       # Dérivées des variables

# Paramètres d'intégration
start = 0
end = Fin
numsteps = 200
t = linspace(start,end,numsteps)

# Résolution
y0=c0
syst_CI=array([y0])                     # Tableau des CI
Sols=odeint(deriv,syst_CI,t)            # Résolution numérique de l'équation différentielle

# Récupération des solutions
y = Sols[:, 0]

# Graphique
fig=subplot()
plot ( t , y, 'b-*', linewidth=1,  label="Concentration du réactif")
grid()
xlabel("t (s)", fontsize=16)            # Label de l'axe des abscisses
ylabel("Concentration en mol/L", fontsize=16)           # Label de l'axe des ordonnées
legend(loc = 'best')

# curseur pour lire une valeur
Cursor(fig, useblit=True, color='red', linewidth=1)
show()



