"""
Exemple de résolution d'équations différentielles :
équation d'ordre 1 : dN/dt + N/tau = 0
"""

from matplotlib.widgets import Cursor
from scipy import *
from pylab import *
from scipy.integrate import odeint      # Module de résolution des équations différentielles

# Coefficients et conditions initiales

L = float(input("entrer la valeur de la constante radioactive (en an-1):    "))
n = float(input("entrer un multiple de tau:..."))
N0 = 1

# calcul de tau theorique
def calculTau(L):
    tau = 1/L       
    return tau

tau=calculTau(L)
print("Valeur de tau :",round(tau,5), " an")
Fin=n*tau

# Création des valeurs de dérivée
def deriv(syst, t):
    y = syst[0]                         # Variable y(t) ici N(t)
    dydt=-y/tau                 # Equation différentielle
    return [dydt]                       # Dérivées des variables

# Paramètres d'intégration
start = 0
end = Fin
numsteps = 200
t = linspace(start,end,numsteps)

# Résolution
y0=N0
syst_CI=array([y0])                     # Tableau des CI
Sols=odeint(deriv,syst_CI,t)            # Résolution numérique de l'équation différentielle

# Récupération des solutions
y = Sols[:, 0]

# Graphique
fig=subplot()
plot ( t , y, 'b-*', linewidth=1,  label="Courbe de décroissance")
grid()
xlabel("t (s)", fontsize=16)            # Label de l'axe des abscisses
ylabel("Proportion du nombre de noyaux restants", fontsize=16)           # Label de l'axe des ordonnées
legend(loc = 'best')

# curseur pour lire une valeur
Cursor(fig, useblit=True, color='red', linewidth=1)
show()



