"""
Exemple de résolution d'équations différentielles :
équation d'ordre 1 : dT/dt + T/tau = B/tau
"""

from matplotlib.widgets import Cursor
from scipy import *
from pylab import *
from scipy.integrate import odeint      # Module de résolution des équations différentielles

# Coefficients et conditions initiales

Te = float(input("entrer la valeur de la température extérieure (en °C) :   "))
T0 = float(input("entrer la valeur de la température initiale (en °C):    "))
h = float(input("entrer la valeur du coefficient d'échange conducto-convectif (en W.m-2.°C-1):    "))
c = float(input("entrer la valeur de la capacité thermique massique (en J.kg-1.°C-1):    "))
m = float(input("entrer la valeur de la masse (en kg):    "))
S = float(input("entrer la valeur de la surface d'échange (en m2):    "))
n = int(input("entrer un multiple de tau:..."))

 #calcul de tau theorique
def calculTau(m,c,h,S):
    tau = m*c/h/S
    return tau

tau=calculTau(m,c,h,S)
print("Valeur de tau :",round(tau,2), " s")

Fin=n*tau


# Création des valeurs de dérivée25
def deriv(syst, t):
    y = syst[0]                         # Variable y(t) ici T(t)
    dydt=-y/tau + Te/tau                # Equation différentielle
    return [dydt]                       # Dérivées des variables

# Paramètres d'intégration
start = 0
end = Fin
numsteps = 200
t = linspace(start,end,numsteps)

# Résolution
y0=T0
syst_CI=array([y0])                     # Tableau des CI
Sols=odeint(deriv,syst_CI,t)            # Résolution numérique de l'équation différentielle

# Récupération des solutions
y = Sols[:, 0]

# Graphique
fig=subplot()
plot ( t , y, 'b-*', linewidth=1,  label="Evolution de la température")
grid()
xlabel("t (s)", fontsize=16)            # Label de l'axe des abscisses
ylabel("Température (°C)", fontsize=16)           # Label de l'axe des ordonnées
ylim(0,Te)
legend(loc = 'best')

# curseur pour lire une valeur
Cursor(fig, useblit=True, color='red', linewidth=1)
show()

